<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use SupNext\Util\Util;
use SupNext\Services\QuoteSheetGrid\DeleteRegionService as Service;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class DeleteRegionController {
  private $util;
  public  $service;

  public function __construct(Util $util, Service $service) {
    $this->util    = $util;
    $this->service = $service;
  }

  public function deleteRegion(Request $request, Response $response): void {
    $data = $request->getParameters();

    try {
      foreach ($data as $region) {
        $region = json_decode($region, true);
        $prodInfo = $this->getInfoToDelete($region);

        $this->service->deleteRegion($region);

        foreach ($prodInfo as $prod) {
          $this->service->procItemcoleAtuCustosup($prod);
        }
      }
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao deletar região: " . $exception->getMessage(), 500);
    }
  }

  public function getInfoToDelete(array $data): array {
    $conditionsArray = [
      "CDFILIAL"    => $data["CDFILIAL"],
      "NRCOLEPRECO" => $data["NRCOLEPRECO"],
      "CDPRODUTO"   => $data["CDPRODUTO"] ?? "T",
      "CDPRODUTO"   => $data["CDPRODUTO"] ?? "T",
      "CDREGIAO"    => $data["CDREGIAO"] ?? "T",
      "CDREGIAO"    => $data["CDREGIAO"] ?? "T",
      "CDFORNECED"  => $data["CDFORNECED"] ?? "T",
      "CDFORNECED"  => $data["CDFORNECED"] ?? "T",
      "CDMARCA"     => $data["CDMARCA"] ?? "T",
      "CDMARCA"     => $data["CDMARCA"] ?? "T",
      "NRORG"       => $data["NRORG"]
    ];

    $prodInfo = $this->util->filteredDataSet($conditionsArray, "getProdInfoToDelete");

    return $prodInfo;
  }
}