<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use SupNext\Util\Util;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class InconsistenciesController {
  private $util;

  public function __construct(Util $util) {
    $this->util = $util;
  }

  public function getInconsistencies(Request $request, Response $response) {
    $data = $request->getParameters();

    try {
      $conditionsArray = [
        "P_CDFILIAL"     => $data["CDFILIAL"],
        "P_LISTACOTACAO" => $data["LISTACOTACAO"] ?? null,
        "P_CDFILIAL"     => $data["CDFILIAL"],
        "P_NRCOLEORILIC" => $data["NRCOLEPRECO"]
      ];

      $inconsistencies = $this->util->filteredDataSet($conditionsArray, "logItemcole");

      return $response->addDataSet(new DataSet("inconsistencies", ["data" => $inconsistencies, "status_code" => 200]));

    } catch (\Exception $exception) {
      throw new \Exception("Erro ao pegar inconsistências: " . $exception->getMessage(), 500);
    }
  }
}