<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use SupNext\Services\QuoteSheetGrid\LoadPurchaseQuantityService as Service;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class LoadPurchaseQuantityController {
  private $service;

  public function __construct(Service $service) {
    $this->service = $service;
  }

  public function loadPurchaseQuantity(Request $request, Response $response) {
    $data = $request->getParameters()["params"];

    try {
      foreach($data as $quote) {
        $this->service->loadQuantityPurchase($quote);
      }
      
      return $response->addDataSet(new DataSet("loadPurchaseQuantity", ["message" => "Atualização da quantidade a comprar realizado com sucesso", "status_code" => 200]));
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao atualizar quantidade a comprar: " . $exception->getMessage(), 500);
    }
  }
}