<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use Teknisa\Libs\Util\Environment;
use SupNext\Controllers\QuoteSheetGrid\AddRegionController as AddRegion;
use SupNext\Services\QuoteSheetGrid\UpdatePaymentMethodService as Service;
use SupNext\Util\Util;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class SavePaymentMethodController {
  private $environment;
  private $addRegion;
  private $service;
  private $util;

  public function __construct(Environment $environment, AddRegion $addRegion, Service $service, Util $util) {
    $this->environment = $environment;
    $this->addRegion = $addRegion;
    $this->service   = $service;
    $this->util      = $util;
  }

  public function savePaymentMethodController(Request $request, Response $response) {
    try {
      $data = $request->getParameters();

      foreach ($data as $quotation) {
        $this->service->updateItem($quotation);
        $this->service->deleteDeadlineItemCol($quotation);

        $quotation["NRORG"] = $this->environment->getNrorg();

        $conditions = [
          "CDFILIAL"    => $quotation["CDFILIAL"],
          "NRCOLEPRECO" => $quotation["NRCOLEPRECO"],
          "NRORG"       => $quotation["NRORG"]
        ];

        $collectItems = $this->util->filteredDataSet($conditions, "verifyItemCole");

        foreach ($collectItems as $item) {
          $this->addRegion->processInsertFormPgtoData($item);
        }
      }

      return $response->addDataSet(new DataSet("updatePaymentMethod", ["message" => "Atualização do método de pagamento realizado com sucesso.", "status_code" => 200]));
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao atualizar forma de pagamento: " . $exception->getMessage(), 500);
    }
  }
}
