<?php

namespace SupNext\Services\QuoteSheetGrid;

use SupNext\Util\Util;

class ChangeValidityService {
    private $util;

    public function __construct(Util $util) {
        $this->util = $util;
    }

    public function updateValidityCollection($data) {
        try {
            $query = "UPDATE COLETAPR
                      SET DTINIVALCOL = :P_DTINIVALCOL, DTFINVALCOL = :P_DTFINVALCOL
                      WHERE CDFILIAL = :P_CDFILIAL
                            AND NRCOLEPRECO = :P_NRCOLEPRECO
                            AND NRORG = :P_NRORG";
            $params = [
                "P_DTINIVALCOL" => $data["DTINIVALITM"],
                "P_DTFINVALCOL" => $data["DTFINVALITM"],
                "P_CDFILIAL"    => $data["CDFILIAL"],
                "P_NRCOLEPRECO" => $data["NRCOLEPRECO"],
                "P_NRORG"       => $data["NRORG"]
            ];

            $this->util->crud($query, $params);
        } catch (Exception $exception) {
            throw new \Exception("Erro ao atualizar validade cotação: " . $exception->getMessage(), 500);
        }
    }

    public function updateValidityItemCole($data) {
        try {
            $query = "UPDATE ITEMCOLE
                      SET DTINIVALITM = :P_DTINIVALITM,
                          DTFINVALITM = :P_DTFINVALITM,
                          IDITMLISPREC = 'N',
                          NRSEQPRELIST = NULL,
                          IDPRECALT = 'N'
                      WHERE CDFILIAL = :P_CDFILIAL
                            AND NRCOLEPRECO = :P_NRCOLEPRECO
                            AND NRORG = :P_NRORG";

            $params = [
                "P_DTINIVALITM" => $data["DTINIVALITM"],
                "P_DTFINVALITM" => $data["DTFINVALITM"],
                "P_CDFILIAL"    => $data["CDFILIAL"],
                "P_NRCOLEPRECO" => $data["NRCOLEPRECO"],
                "P_NRORG"       => $data["NRORG"]
            ];

            $this->util->crud($query, $params);
        } catch (Exception $exception) {
            throw new \Exception("Erro ao atualizar validade item cole: " . $exception->getMessage(), 500);
        }
    }
}
