<?php

namespace SupNext\Services\QuoteSheetGrid;

use SupNext\Util\Util;

class DeleteProductService {
  private $util;

  public function __construct(Util $util) {
    $this->util = $util;
  }

  public function deleteProduct(array $data): void {
    try {
      $query = "DELETE FROM ITEMCOLE
                WHERE CDFILIAL = :P_CDFILIAL
                  AND NRCOLEPRECO = :P_NRCOLEPRECO
                  AND CDPRODUTO = :P_CDPRODUTO
                  AND NRORG = :P_NRORG
                  AND (CDREGIAO = :P_CDREGIAO OR :P_CDREGIAO = 'T')
                  AND (CDFORNECED = :P_CDFORNECED OR :P_CDFORNECED = 'T')
                  AND (CDMARCA = LPAD(:P_CDMARCA, 5, '0')
                  OR LPAD(:P_CDMARCA, 5, '0') = 'T')";

      $params = [
        "P_CDFILIAL"    => $data["CDFILIAL"],
        "P_NRCOLEPRECO" => $data["NRCOLEPRECO"],
        "P_CDREGIAO"    => $data["CDREGIAO"] ?? "T",
        "P_CDFORNECED"  => $data["CDFORNECED"],
        "P_CDPRODUTO"   => $data["CDPRODUTO"],
        "P_CDMARCA"     => $data["CDMARCA"],
        'P_NRORG'       => $data["NRORG"]
      ];

      $this->util->crud($query, $params);
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao deletar produto: " . $exception->getMessage(), 500);
    }
  }
}