<?php

namespace SupNext\Services\QuoteSheetGrid;

use SupNext\Util\Util;

class LoadPurchaseQuantityService {
    private $util;

    public function __construct(Util $util) {
        $this->util = $util;
    }

    public function loadQuantityPurchase(array $data): void {
        try {
            $query = "UPDATE ITEMCOLE
                      SET QTACMPITMCOL = (SELECT SUM((COMP.QTDECOMP-NVL(JACOMP.QTDECOMP,0)) / PRODUTO.VRFATOCONV) AS QTACOMPRAR
                                          FROM PRODUTO, PARASUPRI, (SELECT FILIAL.CDREGIAO, ITEMSOLI.DTPROGENTR, PRODUTO.CDPRODESTO,
                                                                           SUM(ITEMSOLI.QTSOLIPROD*PRODUTO.VRFATOCONV) AS QTDECOMP
                                                                    FROM PRODUTO, ITEMSOLI, FILIAL
                                                                    WHERE (ITEMSOLI.IDITMCONS = 'N')
                                                                          AND (ITEMSOLI.CDFILSOLI = FILIAL.CDFILIAL)
                                                                          AND (ITEMSOLI.CDPRODUTO = PRODUTO.CDPRODUTO)
                                                                          AND (NVL(ITEMSOLI.IDSOLIAPROV,'S') = 'S')
                                                                    GROUP BY FILIAL.CDREGIAO, ITEMSOLI.DTPROGENTR, PRODUTO.CDPRODESTO) COMP,
                                                                    (SELECT FILIAL.CDREGIAO, ITEMAUTF.DTENTRITMSOL, PRODUTO.CDPRODESTO,
                                                                            SUM(ITEMAUTF.QTPROGENTAF*PRODUTO.VRFATOCONV) AS QTDECOMP
                                                                     FROM PRODUTO, ITEMAUTF, AUTOFORNE, FILIAL
                                                                     WHERE (AUTOFORNE.CDFILDEST = ITEMAUTF.CDFILDEST)
                                                                            AND (AUTOFORNE.CDFILLANC = ITEMAUTF.CDFILLANC)
                                                                            AND (AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN)
                                                                            AND (ITEMAUTF.CDFILDEST = FILIAL.CDFILIAL)
                                                                            AND (ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO)
                                                                            AND (AUTOFORNE.IDSITUATUAAF IS NULL)
                                                                            AND (AUTOFORNE.IDAFFORALIM = 'N')
                                                                            AND (AUTOFORNE.IDAUTOFORNEX = 'N')
                                                                            AND (NVL(AUTOFORNE.IDBAIXAAF, '0') <> '5')
                                                                     GROUP BY FILIAL.CDREGIAO, ITEMAUTF.DTENTRITMSOL, PRODUTO.CDPRODESTO) JACOMP
                                            WHERE COMP.CDREGIAO = ITEMCOLE.CDREGIAO
                                                  AND COMP.DTPROGENTR BETWEEN ITEMCOLE.DTINIVALITM
                                                  AND ITEMCOLE.DTFINVALITM
                                                  AND PRODUTO.CDPRODUTO = ITEMCOLE.CDPRODUTO
                                                  AND PRODUTO.CDPRODESTO = COMP.CDPRODESTO
                                                  AND COMP.CDREGIAO = JACOMP.CDREGIAO (+)
                                                  AND COMP.DTPROGENTR = JACOMP.DTENTRITMSOL (+)
                                                  AND COMP.CDPRODESTO = JACOMP.CDPRODESTO (+)
                                                  AND COMP.QTDECOMP-NVL(JACOMP.QTDECOMP,0) > 0
                                                  AND PARASUPRI.CDFILIAL = :P_CDFILIAL
                                                  AND NVL(PARASUPRI.IDCONSPRSOL, 'N') = 'N'
                                            HAVING SUM((COMP.QTDECOMP-NVL(JACOMP.QTDECOMP,0)) / PRODUTO.VRFATOCONV) <> 0
                                            UNION ALL
                                            SELECT SUM(COMP.QTDECOMP-NVL(JACOMP.QTDECOMP,0)) AS QTACOMPRAR FROM PARASUPRI,
                                                   (SELECT FILIAL.CDREGIAO, ITEMSOLI.DTPROGENTR, ITEMSOLI.CDPRODUTO,
                                                           SUM(ITEMSOLI.QTSOLIPROD) AS QTDECOMP
                                                    FROM ITEMSOLI, FILIAL
                                                    WHERE (ITEMSOLI.IDITMCONS = 'N')
                                                          AND (ITEMSOLI.CDFILSOLI = FILIAL.CDFILIAL)
                                                          AND (NVL(ITEMSOLI.IDSOLIAPROV,'S') = 'S')
                                                    GROUP BY FILIAL.CDREGIAO, ITEMSOLI.DTPROGENTR, ITEMSOLI.CDPRODUTO) COMP,
                                                    (SELECT FILIAL.CDREGIAO, ITEMAUTF.DTENTRITMSOL, ITEMAUTF.CDPRODUTO,
                                                            SUM(ITEMAUTF.QTPROGENTAF) AS QTDECOMP
                                                     FROM ITEMAUTF, AUTOFORNE, FILIAL
                                                     WHERE (AUTOFORNE.CDFILDEST = ITEMAUTF.CDFILDEST)
                                                            AND (AUTOFORNE.CDFILLANC = ITEMAUTF.CDFILLANC)
                                                            AND (AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN)
                                                            AND (ITEMAUTF.CDFILDEST = FILIAL.CDFILIAL)
                                                            AND (AUTOFORNE.IDSITUATUAAF IS NULL)
                                                            AND (AUTOFORNE.IDAFFORALIM = 'N')
                                                            AND (AUTOFORNE.IDAUTOFORNEX = 'N')
                                                            AND (NVL(AUTOFORNE.IDBAIXAAF, '0') <> '5')
                                                            GROUP BY FILIAL.CDREGIAO, ITEMAUTF.DTENTRITMSOL, ITEMAUTF.CDPRODUTO) JACOMP
                                            WHERE COMP.CDREGIAO = ITEMCOLE.CDREGIAO
                                                  AND COMP.DTPROGENTR BETWEEN ITEMCOLE.DTINIVALITM
                                                  AND ITEMCOLE.DTFINVALITM
                                                  AND COMP.CDPRODUTO = ITEMCOLE.CDPRODUTO
                                                  AND COMP.CDREGIAO = JACOMP.CDREGIAO (+)
                                                  AND COMP.DTPROGENTR = JACOMP.DTENTRITMSOL (+)
                                                  AND COMP.CDPRODUTO = JACOMP.CDPRODUTO (+)
                                                  AND COMP.QTDECOMP-NVL(JACOMP.QTDECOMP,0) > 0
                                                  AND PARASUPRI.CDFILIAL = :P_CDFILIAL
                                                  AND PARASUPRI.IDCONSPRSOL = 'S'
                                            HAVING SUM(COMP.QTDECOMP-NVL(JACOMP.QTDECOMP,0)) <> 0)
                        WHERE CDFILIAL = :P_CDFILIAL
                              AND NRORG = :P_NRORG
                              AND NRCOLEPRECO = :P_NRCOLEPRECO";
            $params = [
                "P_CDFILIAL"    => $data["CDFILIAL"],
                "P_NRCOLEPRECO" => $data["NRCOLEPRECO"],
                "P_NRORG"       => $data["NRORG"]
            ];

            $this->util->crud($query, $params);
        } catch (Exception $exception) {
            throw new \Exception("Erro ao executar query atualizar quantidade a comprar: " . $exception->getMessage(), 500);
        }
    }
}