<?php

namespace SupNext\Services\QuoteSheetGrid;

use SupNext\Util\Util;

class SaveObservationService {
    private $util;

    public function __construct(Util $util) {
        $this->util = $util;
    }

    public function salvarObservacao(array $data): void {
        try {
            $query = "UPDATE ITEMCOLE
                      SET DSOBSITMCOL = :P_DSOBSITMCOL
                      WHERE CDFILIAL = :P_CDFILIAL
                            AND NRCOLEPRECO = :P_NRCOLEPRECO
                            AND CDREGIAO = :P_CDREGIAO
                            AND CDFORNECED = :P_CDFORNECED
                            AND CDPRODUTO = :P_CDPRODUTO
                            AND CDMARCA = LPAD(:P_CDMARCA, 5, '0')
                            AND NRORG = :P_NRORG";

            $params = [
                "P_DSOBSITMCOL"   => $data["DSOBSITMCOL"],
                "P_CDFILIAL"      => $data["CDFILIAL"],
                "P_NRCOLEPRECO"   => $data["NRCOLEPRECO"],
                "P_CDREGIAO"      => $data["CDREGIAO"],
                "P_CDFORNECED"    => $data["CDFORNECED"],
                "P_CDPRODUTO"     => $data["CDPRODUTO"],
                "P_CDMARCA"       => $data["CDMARCA"],
                "P_NRORG"         => $data["NRORG"]
            ];

            $this->util->crud($query, $params);
        } catch (Exception $exception) {
            throw new \Exception("Erro ao atualizar observação: " . $exception->getMessage(), 500);
        }
    }
}