<?php

namespace SupNext\Services\QuoteSheetGrid;

use SupNext\Util\Util;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class SavePaymentMethodService {
  private $util;

  public function __construct(Util $util) {
    $this->util = $util;
  }

  public function updateItem(array $data): void {
    try {
      $query = "UPDATE ITEMCOLE
                      SET CDFORMPGTO = NULL,
                          IDTPFOPGTCOL = NULL,
                          NRDIAPGFXCOL = NULL,
                          NRPARCPGTCOL = NULL,
                          IDUTDIAPGCOL = NULL
                      WHERE CDFILIAL = :P_CDFILIAL
                            AND NRCOLEPRECO = :P_NRCOLEPRECO
                            AND NRORG = :P_NRORG";

      $params = [
        "P_CDFILIAL"    => $data["CDFILIAL"],
        "P_NRCOLEPRECO" => $data["NRCOLEPRECO"],
        'P_NRORG'       => $data["NRORG"]
      ];

      $this->util->crud($query, $params);
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao atualizar item ao realizar atualização pagamento: " . $exception->getMessage(), 500);
    }
  }

  public function deleteDeadlineItemCol(array $data): void {
    try {
      $query = "DELETE PZOPGTITMCOL
                      WHERE CDFILIAL = :P_CDFILIAL
                            AND NRCOLEPRECO = :P_NRCOLEPRECO
                            AND NRORG = :P_NRORG";

      $params = [
        "P_CDFILIAL"    => $data["CDFILIAL"],
        "P_NRCOLEPRECO" => $data["NRCOLEPRECO"],
        'P_NRORG'       => $data["NRORG"]
      ];

      $this->util->crud($query, $params);
    } catch (Exception $exception) {
      throw new \Exception("Erro ao deletar prazo ItemCole: " . $exception->getMessage(), 500);
    }
  }
}
