<?php

namespace SupNext\Services\QuoteSheetGrid;

use SupNext\Util\Util;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class UpdatePaymentMethodService {
    private $util;

    public function __construct(Util $util) {
        $this->util = $util;
    }

    public function insertPlot(array $data): void {
        try {

            $query = "INSERT INTO PZOPGTITMCOL
                                  (
                                        CDFILIAL,
                                        NRCOLEPRECO,
                                        CDFORNECED,
                                        CDPRODUTO,
                                        CDMARCA,
                                        CDREGIAO,
                                        NRDIASPGTCOL,
                                        VRPERCPGTCOL,
                                        NRORG
                                    )
                                    VALUES
                                    (
                                        :CDFILIAL,
                                        :NRCOLEPRECO,
                                        :CDFORNECED,
                                        :CDPRODUTO,
                                        :CDMARCA,
                                        :CDREGIAO,
                                        :NRDIASPGTCOL,
                                        :VRPERCPGTCOL,
                                        :NRORG
                                    )";

            $param = [
                "CDFILIAL"      => $data["CDFILIAL"],
                "NRCOLEPRECO"   => $data["NRCOLEPRECO"],
                "CDFORNECED"    => $data["CDFORNECED"],
                "CDPRODUTO"     => $data["CDPRODUTO"],
                "CDMARCA"       => $data["CDMARCA"],
                "CDREGIAO"      => $data["CDREGIAO"],
                "NRDIASPGTCOL"  => $data["NRDIAPGFXCOL"],
                "VRPERCPGTCOL"  => $data["NRPARCPGTCOL"],
                "NRORG"         => $data["NRORG"]
            ];

            $this->util->crud($query, $param);
        } catch (Exception $exception) {
            throw new \Exception("Erro ao inserir parcelas: " . $exception->getMessage(), 500);
        }
    }
}
