<?php

namespace SupNext\Services;

class ReportConfigService {
  private $connection;
  private $util;
  private $environment;
  public function __construct($connection, $util, $environment) {
    $this->connection = $connection;
    $this->util       = $util;
    $this->environment = $environment;
  }

  public function insertReportConfig($data) {
    try {
      $query = "INSERT INTO REPORTCONFIG
                (
                  NRREPORTCONFIG,
                  ROUTINE,
                  REPORTCODE,
                  REPORTNAME,
                  IDATIVO,
                  NRORG,
                  CDOPERINCLUSAO,
                  DTINCLUSAO
                )
                VALUES
                (
                  SEQ_REPORTCONFIG.NEXTVAL,
                  'ECOMMERCEAF',
                  :REPORTCODE,
                  :REPORTNAME,
                  'A',
                  :NRORG,
                  :CDOPERINCLUSAO,
                  SYSDATE
                )";

      $parameters = [
          "REPORTCODE"  => $data["REPORTCODE"],
          "REPORTNAME"  => $data["REPORTNAME"],
          "NRORG"       => $this->environment->getNrOrg(),
          "CDOPERINCLUSAO" => $this->environment->getCdoperador()
      ];
      $this->util->crud($query, $parameters);
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao inserir o relatório: " . $exception->getMessage(), 500);
    }
  }

  public function deleteReportConfig($data) {
    try {
      $query = "DELETE FROM REPORTCONFIG
                WHERE
                ROUTINE = 'ECOMMERCEAF'
                AND
                REPORTCODE = :REPORTCODE
                AND
                REPORTNAME = :REPORTNAME
                AND
                NRORG = :NRORG";

      $parameters = [
          "REPORTCODE"  => $data["REPORTCODE"],
          "REPORTNAME"  => $data["REPORTNAME"],
          "NRORG"       => $this->environment->getNrorg()
      ];
      $this->util->crud($query, $parameters);
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao Deletar o relatório: " . $exception->getMessage(), 500);
    }
  }
}