import {
  ModalService, Button,
} from '@zeedhi/common';
import { IEventParam } from '@zeedhi/core';
import { AppState } from '@/controllers/AppState';
import type { IFilterInconsistencies } from '@/controllers/modals/interfaces/QuoteSheetGrid';

export class InconsistenciesController {
  private row: IEventParam<Button>;

  private appState: AppState;

  constructor() {
    this.appState = AppState.getInstance();
  }

  public async createModal(): Promise<void> {
    await ModalService.createFromJson('/modals/quoteSheetGrid/inconsistenciesModal', true);
  }

  public destroyModal(): void {
    ModalService.getModal('inconsistenciesModal')?.destroy();
  }

  public openModal({ row }: IEventParam<Button>): void {
    ModalService.getModal('inconsistenciesModal').show();
    this.row = row;
  }

  public get filterInconsistencies(): IFilterInconsistencies {
    return {
      P_CDFILIAL: this.appState.CDFILIAL,
      P_LISTACOTACAO: null,
      P_NRCOLEORILIC: this.row.NRCOLEPRECO,
    };
  }

  public closeModal(): void {
    ModalService.getModal('inconsistenciesModal').hide();
  }
}
