import { ModalService } from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';

export class ProductsInformationController {
  private utilities!: Utilities;

  constructor() {
    this.utilities = new Utilities();
  }

  public async createModal(): Promise<void> {
    await ModalService.createFromJson(
      '/modals/quoteSheetGrid/ProductsInformationModal',
      true,
    );
  }

  public destroyModal(): void {
    ModalService.getModal('ProductsInformationModal')?.destroy();
  }

  public openModal(): void {
    ModalService.getModal('ProductsInformationModal').show();
  }

  public closeModal(): void {
    ModalService.getModal('ProductsInformationModal').hide();
  }
}
