import { FilterController } from '@/controllers/modals/quoteSheetGrid/FilterController';
import { AddQuotationController } from '@/controllers/modals/quoteSheetGrid/AddQuotationController';
import { InconsistenciesController } from '@/controllers/modals/quoteSheetGrid/InconsistenciesController';
import { ValidateBuyerController } from '@/controllers/modals/quoteSheetGrid/ValidateBuyerController';
import { ChangeValidityController } from '@/controllers/modals/quoteSheetGrid/ChangeValidityController';
import { ReplicateQuotationController } from '@/controllers/modals/quoteSheetGrid/ReplicateQuotationController';
import { AddRegionController } from '@/controllers/modals/quoteSheetGrid/AddRegionController';
import { AddSupplierController } from '@/controllers/modals/quoteSheetGrid/AddSupplierController';
import { AddProductController } from '@/controllers/modals/quoteSheetGrid/AddProductController';
import { ObservationController } from '@/controllers/modals/quoteSheetGrid/ObservationController';
import { ProductsInformationController } from '@/controllers/modals/quoteSheetGrid/ProductsInformationController';
import { PriceAdjustmentController } from '@/controllers/modals/quoteSheetGrid/PriceAdjustmentController';
import { LoadBestPricesController } from '@/controllers/modals/quoteSheetGrid/LoadBestPricesController';
import { SpreadsheetInformationController } from '@/controllers/modals/quoteSheetGrid/SpreadsheetInformationController';

export class ModalsController {
  private modals: any[];

  constructor() {
    this.modals = [
      new FilterController(),
      new AddQuotationController(),
      new InconsistenciesController(),
      new ValidateBuyerController(),
      new ChangeValidityController(),
      new ReplicateQuotationController(),
      new AddRegionController(),
      new AddSupplierController(),
      new AddProductController(),
      new ObservationController(),
      new ProductsInformationController(),
      new PriceAdjustmentController(),
      new LoadBestPricesController(),
      new SpreadsheetInformationController(),
    ];
  }

  public createModals(): void {
    this.modals.forEach((modal) => modal.createModal());
  }

  public destroyModals(): void {
    this.modals.forEach((modal) => modal.destroyModal());
  }
}
